Markers (TODO / FIXME)

soap/SoapRelationshipHelper.php1

Type Line Description
fixme 199 This is not a DB-safe code. Does not work on SQL Server & Oracle.

data/SugarBean.php4

Type Line Description
todo 175 This should be replaced by altering the current user before the call to save.
fixme 3928 Bug? we should remove the magic number -99
todo 5341 this function needs adjustment
todo 1344 Add support for field type validation and encoding of parameters.

include/SugarFields/Fields/Collection/ViewSugarFieldCollection.php2

Type Line Description
todo 241 Change to an other view
todo 461 the 'select' button is not fully working. We should use the sqs_objects in open_popup instead of the parameter.

include/utils.php3

Type Line Description
todo 703 Update to use global cache
todo 1745 Clint 5/20 - Make this function more generic so that it can take in the target form and field names as variables
todo 4313 this won't work completely right until we impliment css compression and combination for now, we'll just include the last css file found.

include/workflow/field_utils.php1

Type Line Description
fixme 786 Special cases for known non-db but allowed fields

include/utils/LogicHook.php1

Type Line Description
todo 207 Make a factory for these classes. Cache instances accross uses

include/utils/db_utils.php1

Type Line Description
todo 51 Make this utilize the external caching mechanism after re-testing (see log on r25320). Bug 49489 - removed caching of to_html strings as it was consuming memory and never releasing it

include/utils/layout_utils.php2

Type Line Description
todo 282 refactor this into the base Popup_Picker class
todo 328 refactor this into the base Popup_Picker class

include/Expressions/metadata/metatojs.php1

Type Line Description
todo 15 remove aliasing

include/Expressions/Expression/String/ContainsExpression.php1

Type Line Description
todo 27 add caching of return values

include/Expressions/Expression/String/ConcatenateExpression.php1

Type Line Description
todo 27 add caching of return values

include/Expressions/Expression/Numeric/AddExpression.php1

Type Line Description
todo 26 add caching of return values

include/Expressions/Expression/Numeric/AverageExpression.php1

Type Line Description
todo 26 add caching of return values

include/Expressions/Expression/Numeric/MultiplyExpression.php1

Type Line Description
todo 26 add caching of return values

include/Expressions/Expression/Numeric/DivideExpression.php1

Type Line Description
todo 26 add caching of return values

include/Expressions/Expression/Numeric/SubtractExpression.php1

Type Line Description
todo 26 add caching of return values

include/phpmailer/class.phpmailer.php3

Type Line Description
todo 1408 check this worked
todo 1916 using /e (equivalent to eval()) is probably not a good idea
todo 2346 Should this not be using __set() magic function?

include/SugarOAuthServer.php1

Type Line Description
fixme 75 add ts/nonce verification

include/connectors/utils/ConnectorUtils.php1

Type Line Description
todo 70 if we don't know this connector, should we decide it's enabled or disabled?

include/HTMLPurifier/HTMLPurifier.standalone.php36

Type Line Description
fixme 611 ^^ not always, see start and value of list items
todo 12658 create custom child-definition for noscript that
todo 12664 convert this to new syntax, main problem is getting
todo 60 We need an easier way to inject strategies using the configuration object.
todo 1250 Refactor duplicate elements into common class (probably using composition, not inheritance).
todo 1340 Reconsider some of the public member variables
todo 2215 Unit test
todo 2454 Create a separate maintenance file advanced users can use to cache their custom HTMLDefinition, which can be loaded via a configuration directive
todo 2454 Implement memcached
todo 3952 Refactor interface so that configuration/context is determined upon instantiation, no need for messy generateFromTokens() calls
todo 3952 Make some of the more internal functions protected, and have unit tests work around that
todo 4184 This really ought to be protected, but until we have a facility for properly generating HTML here w/o using tokens, it stays public.
todo 4587 Give this its own class, probably static interface
todo 4633 Consider making some member functions protected
todo 5336 Allow injectors to request a re-run on their output. This would help if an operation is recursive.
todo 5610 Make it private, fix usage in HTMLPurifier_LanguageTest
todo 5682 Implement conditionals? Right now, some messages make reference to line numbers, but those aren't always available
todo 5740 Serialized cache for languages
todo 6310 Consider making protected
todo 6362 Consider making protected
todo 6874 Port DirectLex to use this
todo 8064 Make protected
todo 8846 Make protected
todo 9487 Make protected
todo 9493 Make protected
todo 11652 Make protected
todo 11662 Make protected
todo 11672 Make protected
todo 12880 Figure out how to protect some of these methods/properties
todo 12909 Wildcard matching and error reporting when an added or subtracted fix has no effect.
todo 13365 Ensure all states are unit tested, including variations as well.
todo 13365 Make a graph of the flow control for this Injector.
todo 14280 Reread XML spec and document differences.
todo 14816 Enable nodes to be bubbled out of the structure.
todo 16638 Validate the email address
todo 16638 Filter allowed query parameters

include/HTMLPurifier/standalone/HTMLPurifier/Lexer/PEARSax3.php1

Type Line Description
todo 3 Generalize so that XML_HTMLSax is also supported.

include/HTMLPurifier/standalone/HTMLPurifier/Filter/ExtractStyleBlocks.php1

Type Line Description
todo 36 Extend to indicate non-text/css style blocks

include/HTMLPurifier/standalone/HTMLPurifier/Printer/HTMLDefinition.php1

Type Line Description
todo 231 Also add information about internal state

include/HTMLPurifier/standalone/HTMLPurifier/Printer/ConfigForm.php1

Type Line Description
todo 3 Rewrite to use Interchange objects

include/TimeDate.php5

Type Line Description
fixme 1080 if the string is short, should we assume date or time?
todo 1150 should we return clone?
todo 293 add caching
todo 323 add caching
todo 1887 There is hardcoded HTML in here that does not allow for localization of the AM/PM am/pm Strings in this drop down menu. Also, perhaps change to the substr_count function calls to strpos TODO: Remove after full switch to fields

include/SubPanel/SubPanel.php1

Type Line Description
todo 143 what about unions?

include/SubPanel/registered_layout_defs.php1

Type Line Description
todo 26 add global memory cache support here. If there is an in memory cache, leverage it.

include/SugarSearchEngine/Elastic/SugarSearchEngineElastic.php2

Type Line Description
todo 488 Determine why term filters aren't working with the hyphen present.
fixme 736 convert to use autoloader

include/SugarSearchEngine/Elastic/Elastica/Query.php1

Type Line Description
todo 54 Implement queries without

include/SugarSearchEngine/Elastic/Elastica/Client.php2

Type Line Description
todo 220 similar to delete ids but with type and index inside files
todo 281 Test

include/SugarSearchEngine/Elastic/Elastica/Type.php2

Type Line Description
todo 231 To be implemented, can also be implemented on index and client level (see docs)
todo 245 Not tested yet

include/SugarSearchEngine/Elastic/Elastica/Filter/Ids.php2

Type Line Description
todo 44 Shouldn't this throw an exception?
todo 60 Shouldn't this throw an exception or let handling of invalid params to ES?

include/SugarSearchEngine/Elastic/Elastica/Filter/Script.php1

Type Line Description
todo 36 check if should be renamed to setScript?

include/SugarSearchEngine/Elastic/Elastica/Filter/GeoDistance.php1

Type Line Description
todo 39 validate distance?

include/SugarSearchEngine/Elastic/Elastica/Index.php3

Type Line Description
todo 110 doesn't seem to work?
todo 282 add additional cache clean arguments
todo 294 Add option for refresh

include/SugarSearchEngine/Elastic/Elastica/Index/Status.php2

Type Line Description
todo 63 Update as soon as new API is implmented
todo 75 Update as soon as new API is implmented

include/SugarSearchEngine/Elastic/Elastica/Type/Abstract.php2

Type Line Description
todo 2 Add some settings examples to code
todo 2 Add some settings examples to code

include/SugarSearchEngine/Elastic/Elastica/Transport/Http.php1

Type Line Description
todo 58 REFACTOR

include/SugarSearchEngine/Elastic/Elastica/Transport/Abstract.php1

Type Line Description
todo 12 set default method?

include/Popups/PopupSmarty.php1

Type Line Description
todo 542 cleanup the construction of $addform

include/Popups/Popup_picker.php1

Type Line Description
todo 111 cleanup the construction of $addform

include/SugarQueue/SugarJobQueue.php3

Type Line Description
todo 150 soft-delete old done jobs?
todo 173 tranaction start?
todo 197 commit/check?

include/MySugar/MySugar.php1

Type Line Description
todo 595 the css is not fully inherited in this file

include/controller/Controller.php2

Type Line Description
todo 240 jgreen - this is only single axis check_wall mechanism, will need to upgrade this to double axis
todo 298 jgreen - Add dual axis motion

include/upload_file.php2

Type Line Description
fixme 425 Translate
fixme 437 Translate

include/generic/SugarWidgets/SugarWidgetSubPanelTopButton.php2

Type Line Description
todo 30 rename defines to layout defs and make it a member variable instead of passing it multiple layers with extra copying.
todo 168 move this out and get $additionalFormFields working properly

include/generic/SugarWidgets/SugarWidgetFielddatetimecombo.php1

Type Line Description
todo 27 now for date time field , we just search from date start to date end. The time is from 00:00:00 to 23:59:59

include/generic/SugarWidgets/SugarWidgetSubPanelTopScheduleMeetingButton.php1

Type Line Description
todo 82 move this out and get $additionalFormFields working properly

include/generic/SugarWidgets/SugarWidgetSubPanelTopScheduleCallButton.php1

Type Line Description
todo 82 move this out and get $additionalFormFields working properly

include/generic/SugarWidgets/SugarWidgetSubPanelCloseButton.php1

Type Line Description
todo 20 Rename this to close button field

include/generic/SugarWidgets/SugarWidgetSubPanelTopCreateTaskButton.php1

Type Line Description
todo 82 move this out and get $additionalFormFields working properly

include/generic/SugarWidgets/SugarWidgetSubPanelRelFieldEditButton.php1

Type Line Description
todo 20 Rename this to edit link

include/generic/SugarWidgets/SugarWidgetSubPanelTopButtonQuickCreate.php1

Type Line Description
todo 92 move this out and get $additionalFormFields working properly

include/generic/SugarWidgets/SugarWidgetSubPanelEditButton.php1

Type Line Description
todo 20 Rename this to edit link

include/generic/SugarWidgets/SugarWidget.php1

Type Line Description
todo 17 move me out of generic

include/generic/SugarWidgets/SugarWidgetSubPanelTopCreateNoteButton.php1

Type Line Description
todo 82 move this out and get $additionalFormFields working properly

include/SugarCache/SugarCache.php1

Type Line Description
todo 78 make it so developers can extend this somehow

include/SugarDateTime.php3

Type Line Description
todo 130 better way to not risk locale stuff problems?
fixme 554 locale?
fixme 563 locale?

include/Dashlets/DashletRssFeedTitle.php1

Type Line Description
todo 46 use curl with waiting timeout instead of fopen

include/MassUpdate.php2

Type Line Description
todo 191 define filter array here to optimize the query
todo 513 allow ACL access for Delete to be set false always for users

include/Sugarpdf/Sugarpdf.php2

Type Line Description
todo 402 ISSUE - width in % for the td have to be multiply by the number of column.
todo 622 explode with space is not the best things to do...

include/database/MssqlManager.php1

Type Line Description
fixme 1972 go back to the original DB

include/database/DBManager.php2

Type Line Description
todo 708 : refactor engine param to be more generic
todo 794 : refactor engine param to be more generic

include/MVC/View/views/view.gs.php1

Type Line Description
todo 135 Handle enums since we are destroying the key.

include/ListView/ListViewXTPL.php1

Type Line Description
todo 120 make popups / listview check saving the same

include/ListView/ListViewSmarty.php1

Type Line Description
todo 201 Cleanup, better logic for which modules are exempt from the new messaging.

include/ListView/ListView.php1

Type Line Description
todo 268 expensive and needs to be removed and done better elsewhere

include/externalAPI/WebEx/ExtAPIWebEx.php4

Type Line Description
fixme 113 Use TimeDate
todo 117 what's openTime?
fixme 309 Translate
fixme 322 Translate

include/externalAPI/Google/ExtAPIGoogle.php2

Type Line Description
fixme 105 bail if auth token not set
fixme 203 can't we just use the httpClient? It should add auth automatically

include/externalAPI/LotusLive/ExtAPILotusLive.php3

Type Line Description
todo 270 Implement this, get the meeting information from the provided tags.
fixme 392 Translate
fixme 471 Translate

include/externalAPI/Base/OAuthPluginBase.php2

Type Line Description
fixme 166 error checking here
fixme 178 error checking here

include/externalAPI/Base/ExternalAPIBase.php1

Type Line Description
fixme 48 check if the bean is validated, if not, refuse it?

include/externalAPI/cmis_repository_wrapper.php15

Type Line Description
todo 120 Make this work with cookies
todo 215 Make this storage optional
todo 304 Review
todo 386 Maybe use ->length=0 to even detect null values
todo 402 RRM FIX THIS
todo 464 RRM FIX THIS
todo 693 Fix Type Caching with missing properties
todo 760 Refactor Type Entries Caching
todo 778 Refactor Type Entries Caching
todo 782 Need GenURLQueryString Utility
todo 784 Need right URL
todo 840 Need GenURLQueryString Utility
todo 850 Need GenURLQueryString Utility
todo 860 Need GenURLQueryString Utility
todo 1112 Need Proper Query String Handling

include/externalAPI/Facebook/ExtAPIFacebook.php3

Type Line Description
fixme 43 Translate
fixme 66 Translate
fixme 101 Translate

include/externalAPI/GoToMeeting/ExtAPIGoToMeeting.php4

Type Line Description
fixme 113 Use TimeDate
fixme 190 Use TimeDate
fixme 259 Translate
fixme 270 Translate

include/externalAPI/IBMSmartCloud/ExtAPIIBMSmartCloud.php3

Type Line Description
todo 266 Implement this, get the meeting information from the provided tags.
fixme 388 Translate
fixme 467 Translate

portal/include/utils.php2

Type Line Description
todo 403 Update to use global cache
todo 1206 Clint 5/20 - Make this function more generic so that it can take in the target form and field names as variables

portal/index.php1

Type Line Description
todo 356 move this code into $theme/header.php so that we can be within the and tags.

modules/Administration/controller.php1

Type Line Description
todo 55 find way to enforce order

modules/ModuleBuilder/controller.php1

Type Line Description
todo 563 FOR MB

modules/ModuleBuilder/parsers/views/SubpanelMetaDataParser.php1

Type Line Description
todo 41 check the implementations

modules/ModuleBuilder/parsers/views/UndeployedSubpanelImplementation.php1

Type Line Description
todo 44 history

modules/ModuleBuilder/parsers/relationships/AbstractRelationships.php1

Type Line Description
todo 157 error handling in case we get a badly formed definition and hence relationship

modules/ModuleBuilder/views/view.labels.php1

Type Line Description
todo 39 Bundle Studio and ModuleBuilder label handling to increase maintainability.

modules/ModuleBuilder/views/view.tree.php1

Type Line Description
todo 37 Bundle Studio and ModuleBuilder label handling to increase maintainability.

modules/ModuleBuilder/MB/MBModule.php1

Type Line Description
todo 838 replace by similar mechanism to StudioModule to determine the list of available views for this module

modules/ModuleBuilder/MB/MBPackage.php1

Type Line Description
todo 475 private changed protected for testing purposes.

modules/Products/SubPanelView.php1

Type Line Description
todo 78 will this ever get called? accounts detailview does not have a select button for products subpanel

modules/Teams/TeamSet.php1

Type Line Description
todo 85 CONCAT

modules/Teams/TeamSetManager.php1

Type Line Description
todo 387 we can remove the team_set_id from the WHERE if we don't care about reassignment

modules/Teams/Popup_picker.php1

Type Line Description
todo 123 cleanup the construction of $addform

modules/Calendar/CalendarUtils.php2

Type Line Description
todo 176 CHECK DATETIME VARIABLE
todo 357 CHECK DATETIME VARIABLE

modules/Groups/EditView.php1

Type Line Description
todo 31 figure out why i have to hard-code this data load?

modules/Users/views/view.edit.php1

Type Line Description
fixme 137 Translate error prefix

modules/Contacts/Popup_picker.php1

Type Line Description
todo 71 cleanup the construction of $addform

modules/Emails/Email.php2

Type Line Description
todo 1165 make this update?
todo 3128 Consider moving to SugarBean to allow other models to set fields to NULL

modules/Configurator/metadata/SugarpdfSettingsdefs.php1

Type Line Description
todo 241 translate

modules/vCals/HTTP_WebDAV_Server_vCal.php4

Type Line Description
todo 91 throw if not a directory
todo 274 support this if ext/zlib filters are available
todo 294 we have to ensure that implementations support this or send 501 instead
todo 300 maybe we can just pretend here?

modules/SugarFeed/Dashlets/SugarFeedDashlet/SugarFeedDashlet.php1

Type Line Description
fixme 272 Actually calculate the oldest sugar feed we can see, once we get an API that supports this sort of filter.

modules/WorkFlowActionShells/Popup_picker.php1

Type Line Description
todo 58 GET ALL ALERTS HERE

modules/Reports/Report.php4

Type Line Description
fixme 832 needs DB-independent code here
fixme 1822 see if we need to handle NULLs on GROUP BY
fixme 1852 this needs to be fixed.. turn on summary sorting
todo 2317 wp this should be done in the widget

modules/Reports/schedule/ReportSchedule.php1

Type Line Description
todo 35 This code should never be used

modules/History/metadata/subpaneldefs.php1

Type Line Description
todo 29 try and merge with the activities

modules/OptimisticLock/LockResolve.php1

Type Line Description
fixme 26 Replace the comparison here with a function from SugarWidgets

modules/Activities/metadata/subpaneldefs.php2

Type Line Description
todo 32 remove name=nothing and make it safe
todo 33 update layout editor to match new file structure

modules/Schedulers/SchedulerDaemon.php2

Type Line Description
todo 428 figure if this is better than the above check
todo 504 make sure this will fail gracefully

modules/Meetings/Meeting.php1

Type Line Description
todo 859 do we really need focus, name and view params for this function

modules/InboundEmail/InboundEmail.php3

Type Line Description
todo 4477 add team security to this query
todo 4667 figure out if the since date is UDT
todo 5321 - set team_id, team_set for new UI

modules/Campaigns/QueueCampaign.php1

Type Line Description
todo 139 SM: may want to move this to query clause above instead

modules/SchedulersJobs/SchedulersJob.php4

Type Line Description
todo 132 figure out what error is thrown when no more apache instances can be spun off
todo 155 make the below configurable
todo 232 what we do if job fails, notify somebody?
todo 241 what we do if job fails, notify somebody?

modules/WorkFlowAlertShells/Popup_picker.php1

Type Line Description
todo 58 GET ALL ALERTS HERE

modules/Currencies/Currency.php1

Type Line Description
todo 461 refactor this. unit tests should not have static dependencies

modules/Leads/ConvertLayoutMetadataParser.php1

Type Line Description
todo 171 Add history support to the convert leads layout editor.

modules/Leads/views/view.convertlead.php1

Type Line Description
todo 266 This should probably be on the smarty template

modules/Notes/Note.php1

Type Line Description
todo 206 Seems odd we need to clear out these values so that list views don't show the previous rows value if current value is blank

modules/SNIP/iCalParser.php1

Type Line Description
todo 287 try to find right timezone?

modules/DynamicFields/DynamicField.php1

Type Line Description
todo 476 fix this - saveToVardefs() updates GLOBAL['dictionary'] correctly, obtaining its information directly from the fields_meta_data table via buildCache()...

modules/Import/sources/ImportFile.php1

Type Line Description
todo 265 Add auto detection for field delim and qualifier properteis.

service/v4/SugarWebServiceImplv4.php1

Type Line Description
todo 758 permissions?

service/v4/SugarWebServiceUtilv4.php1

Type Line Description
todo 618 handle role

install/install_utils.php1

Type Line Description
fixme 1821 where should it be?